package net.eusashead.hateoas.header.impl;

/*
 * #[license]
 * spring-responseentitybuilder
 * %%
 * Copyright (C) 2013 Eusa's Head
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * %[license]
 */

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import net.eusashead.hateoas.header.AllowHeader;

import org.springframework.http.HttpMethod;

public class AllowHeaderImpl implements AllowHeader {

	public static final String ALLOWS_HEADER = "Allows";
	
	private final Set<HttpMethod> methods;
	
	public AllowHeaderImpl(HttpMethod...methods) {
		Set<HttpMethod> allowed = new HashSet<HttpMethod>();
		allowed.addAll(Arrays.asList(methods));
		this.methods = allowed;
	}
	
	@Override
	public String getName() {
		return ALLOWS_HEADER;
	}

	@Override
	public Set<HttpMethod> getValue() {
		return methods;
	}

}
