package net.eusashead.hateoas.header.impl;

/*
 * #[license]
 * spring-responseentitybuilder
 * %%
 * Copyright (C) 2013 Eusa's Head
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * %[license]
 */

import java.net.URI;
import java.net.URISyntaxException;

import net.eusashead.hateoas.header.LocationHeader;

import org.springframework.web.util.UriTemplate;

public class LocationHeaderImpl implements LocationHeader {
	
	public static final String LOCATION_HEADER = "Location";
	
	private final URI value;

	public LocationHeaderImpl(URI uri) {
		this.value = uri;
	}
	
	public LocationHeaderImpl(String uri) {
		try {
			this.value = new URI(uri);
		} catch (URISyntaxException e) {
			throw new IllegalArgumentException(String.format("URI %s has incorrect syntax.", uri));
		}
	}
	
	public LocationHeaderImpl(String uriTemplate, Object... objects) {
		UriTemplate uri = new UriTemplate(uriTemplate);
		this.value = uri.expand(objects);
	}
	
	@Override
	public String getName() {
		return LOCATION_HEADER;
	}

	@Override
	public URI getValue() {
		return this.value;
	}

}
